DROP TABLE IF EXISTS eg_api_loan_extend;
CREATE TABLE eg_api_loan_extend(
                                   `id` bigint(64) NOT NULL   COMMENT 'id' ,
                                   `create_uid` VARCHAR(64)    COMMENT '创建人id' ,
                                   `create_username` VARCHAR(64)    COMMENT '创建人' ,
                                   `gmt_create` DATETIME    COMMENT '创建时间' ,
                                   `modify_uid` VARCHAR(32)    COMMENT '更新人' ,
                                   `modify_username` VARCHAR(64)    COMMENT '修改人' ,
                                   `gmt_modify` DATETIME    COMMENT '修改时间' ,
                                   `status` VARCHAR(10)    COMMENT '有效（Y 有效 N 无效）' ,
                                   `api_id` bigint(64)    COMMENT 'eg_api主键' ,
                                   `share_range` VARCHAR(255)    COMMENT '共享范围' ,
                                   `protocol` VARCHAR(255)    COMMENT '协议范围' ,
                                   `share_purpose` VARCHAR(255)    COMMENT '共享目的' ,
                                   `need_check` INT(4)    COMMENT '是否需要撞库0：不需要；1：需要' ,
                                   `share_type` VARCHAR(255)    COMMENT '共享方式' ,
                                   PRIMARY KEY (id)
)  COMMENT = '接出助贷api的扩展表';

DROP TABLE IF EXISTS eg_api_product_extend;
CREATE TABLE eg_api_product_extend(
                                      `id` bigint(64) NOT NULL   COMMENT 'id' ,
                                      `create_uid` VARCHAR(64)    COMMENT '创建人id' ,
                                      `create_username` VARCHAR(64)    COMMENT '创建人' ,
                                      `gmt_create` DATETIME    COMMENT '创建时间' ,
                                      `modify_uid` VARCHAR(32)    COMMENT '更新人' ,
                                      `modify_username` VARCHAR(64)    COMMENT '修改人' ,
                                      `gmt_modify` DATETIME    COMMENT '修改时间' ,
                                      `status` VARCHAR(10)    COMMENT '有效（Y 有效 N 无效）' ,
                                      `api_id` bigint(64)    COMMENT 'eg_api主键' ,
                                      `share_range` VARCHAR(255)    COMMENT '共享范围' ,
                                      `protocol` VARCHAR(255)    COMMENT '协议范围' ,
                                      `share_purpose` VARCHAR(255)    COMMENT '共享目的' ,
                                      `share_type` VARCHAR(255)    COMMENT '共享方式' ,
                                      `need_check` INT(4)    COMMENT '是否需要撞库0：不需要；1：需要' ,
                                      PRIMARY KEY (id)
)  COMMENT = '接出产品api扩展表';

CREATE TABLE `eg_api` (
                          `id` bigint(64) NOT NULL COMMENT 'id',
                          `create_uid` varchar(64) DEFAULT NULL COMMENT '创建人id',
                          `create_username` varchar(64) DEFAULT NULL COMMENT '创建人',
                          `gmt_create` datetime DEFAULT NULL COMMENT '创建时间',
                          `modify_uid` varchar(32) DEFAULT NULL COMMENT '更新人',
                          `modify_username` varchar(64) DEFAULT NULL COMMENT '修改人',
                          `gmt_modify` datetime DEFAULT NULL COMMENT '修改时间',
                          `status` varchar(10) DEFAULT NULL COMMENT '有效（Y 有效 N 无效）',
                          `api_code` varchar(64) DEFAULT NULL COMMENT '业务编码',
                          `api_name` varchar(64) DEFAULT NULL COMMENT '名称',
                          `api_type` varchar(20) DEFAULT NULL COMMENT 'api类型',
                          PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='api信息表';

CREATE TABLE `eg_api_endpoint` (
                                   `id` bigint(64) NOT NULL,
                                   `create_uid` varchar(64) DEFAULT NULL COMMENT '乐观锁',
                                   `create_username` varchar(64) DEFAULT NULL COMMENT '创建人',
                                   `gmt_create` datetime DEFAULT NULL COMMENT '创建时间',
                                   `modify_uid` varchar(64) DEFAULT NULL COMMENT '更新人',
                                   `modify_username` varchar(64) DEFAULT NULL COMMENT '更新人',
                                   `status` varchar(32) DEFAULT NULL COMMENT '有效（Y 有效 N 无效）',
                                   `api_config` blob COMMENT '配置',
                                   `api_code` varchar(32) DEFAULT NULL COMMENT 'code配置',
                                   `desc` varchar(255) DEFAULT NULL COMMENT '描述',
                                   `api_id` bigint(64) DEFAULT NULL COMMENT 'apiId',
                                   `gmt_modify` datetime DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP,
                                   `api_name` varchar(255) DEFAULT NULL COMMENT 'api名称',
                                   `request_config` varchar(255) DEFAULT NULL COMMENT '请求配置',
                                   `response_config` varchar(255) DEFAULT NULL COMMENT '响应设置',
                                   `memo` varchar(255) DEFAULT NULL COMMENT '备注',
                                   PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='api通道表';