package com.hrsk.cloud.eg.app.api;


import com.hrsk.cloud.eg.app.route.EndpointRouteService;
import com.hrsk.cloud.eg.clinet.dto.data.command.ApiInvokeParamCmd;
import com.hrsk.cloud.eg.domain.common.constant.BusinessServiceEnums;
import com.hrsk.cloud.eg.domain.common.constant.egress.EgRouteTypeEnum;
import com.hrsk.pangu.dto.SingleResponse;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author zhangyy
 * @version 1.0
 * @description: ApiService
 * @date 2024/11/6 14:07
 */
@Slf4j
@Service
public class ApiGatewayService {

    @Resource
    private List<EndpointRouteService> endpointRouteServices;



    /**
     * @description:  网管寻找对应的服务
     * @param:
     * @return:
     * @author zhangyy
     * @date: 2024/11/6 16:19
     */
  public   SingleResponse invoke(ApiInvokeParamCmd apiInvokeParamCmd){
    try {
       if (EgRouteTypeEnum.CHECK_INTO.getCode().equals(apiInvokeParamCmd.getRoute())){
           Map<String, EndpointRouteService> collect = endpointRouteServices.stream().collect(Collectors.toMap(EndpointRouteService::getRoute, EndpointRouteService -> EndpointRouteService));
         return   collect.get(apiInvokeParamCmd.getRoute()).apiEndPoint(apiInvokeParamCmd);
       }
    }catch (Exception e){
      log.error("网关错误",e.getMessage());
    }
    return SingleResponse.buildFailure(BusinessServiceEnums.FAIL.getCode(), BusinessServiceEnums.FAIL.getMessage());
  }

}
