package com.hrsk.cloud.eg.app.loan.customize;

import com.hrsk.cloud.eg.app.loan.executor.checkInto.CheckCmdExe;
import com.hrsk.cloud.eg.clinet.dto.data.command.LoanParamCmd;
import com.hrsk.cloud.eg.clinet.vo.DataVo;
import com.hrsk.cloud.eg.domain.common.constant.egress.EgressApiEndpointIntegrationModeEnum;
import com.hrsk.pangu.dto.SingleResponse;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;


/**
 * @author zhangyy
 * @version 1.0
 * @description: CodeStrategyCmd
 * @date 2024/11/6 16:14
 */
@Service
public class CodeStrategyCmd implements CheckCmdExe {

    @Resource
    private ApiCustomizeRouteService apiCustomizeRouteService;

    @Override
    public SingleResponse route(LoanParamCmd checkIntoParamCmd) {
        DataVo dataVo = apiCustomizeRouteService.loanCheckInto(checkIntoParamCmd);
        return SingleResponse.of(dataVo);
    }

    @Override
    public String getMode() {
        return EgressApiEndpointIntegrationModeEnum.CUSTOMIZE.getCode();
    }
}
