package com.hrsk.cloud.eg.app.loan.executor;

import com.alibaba.fastjson2.JSONObject;
import com.google.common.collect.Lists;
import com.hrsk.cloud.eg.clinet.constant.BusinessPrefixEnum;
import com.hrsk.cloud.eg.domain.api.HttpApiConfig;
import com.hrsk.cloud.eg.domain.api.KeyValueObject;
import com.hrsk.cloud.eg.domain.api.common.ApiPayloadTypeEnum;
import com.hrsk.cloud.eg.domain.api.common.ValueObjectTypeEnum;
import com.hrsk.cloud.eg.infrastructure.repository.database.entity.EgApiDo;
import com.hrsk.cloud.eg.infrastructure.repository.database.entity.EgApiEndpointDo;
import com.hrsk.cloud.eg.infrastructure.service.EgApiEndpointService;
import com.hrsk.cloud.eg.infrastructure.service.EgApiService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author zhangyy
 * @version 1.0
 * @description: GenerateCheckIntoHttpApiConfigV2Service
 * @date 2024/9/9 16:35
 */
@Slf4j
@Component
public class GenerateCheckIntoHttpApiConfigV2CmdExe {
    @Resource
    private EgApiService egApiService;

    @Resource
    private EgApiEndpointService egApiEndpointService;
    /**
     * @description:  灏瀚无崟
     * @author zhangyy
     * @date 2024/9/9 16:22
     * @version 1.0
     */
    public void generateGexinjinfuConfig(String openApiConfig) {
        EgApiDo egApiDo=new EgApiDo();
        egApiDo.setApiCode("EG:"+ BusinessPrefixEnum.CHECK_INTO_PREFIX.getCode()+":Gexinjinfu");
        egApiDo.setApiName(BusinessPrefixEnum.CHECK_INTO_PREFIX.getMsg());
        egApiService.save(egApiDo);
        JSONObject jsonObject = JSONObject.parseObject(openApiConfig);
        EgApiEndpointDo egApiEndpointDo=new EgApiEndpointDo();
        egApiEndpointDo.setApiId(egApiDo.getId());
        egApiEndpointService.save(egApiEndpointDo);
    }

    private HttpApiConfig createGexinjinfuCheckIntoBean(String openApiConfig) {
        JSONObject jsonObject=JSONObject.parseObject(openApiConfig);
        HttpApiConfig httpApiConfig = new HttpApiConfig();
        httpApiConfig.setUrl(jsonObject.getString("url")+"/api/rsatg/checkmobile");
        httpApiConfig.setMethod("POST");
        httpApiConfig.setContentType(ApiPayloadTypeEnum.APPLICATION_JSON.getCode());
        List<KeyValueObject> headers = Lists.newArrayList();
        KeyValueObject head=new KeyValueObject();
        head.setType(ValueObjectTypeEnum.BASIC.getType());
        head.setKey("Content-Type");
        head.setValue("application/x-www-form-urlencoded; charset=UTF-8");
        headers.add(head);
        httpApiConfig.setHeader(headers);
        List<KeyValueObject> search = Lists.newArrayList();
        KeyValueObject searchKey=new KeyValueObject();
        searchKey.setType(ValueObjectTypeEnum.SPEL.getType());
        searchKey.setKey("mobnum_md5");
        searchKey.setValue("#param.user.phoneMd5");
        search.add(searchKey);
        httpApiConfig.setSearch(search);
//        JSONObject body=new  JSONObject();
//        body.put("channelSource",jsonObject.getString("channelSource"));
//        body.put("channelCode",jsonObject.getString("channelCode"));
//        KeyValueObject attackPhone=new KeyValueObject();
//        attackPhone.setType("spel");
//        attackPhone.setValue("#param.user.phoneMd5");
//        body.put("md5_phone","#"+JSONObject.toJSONString(attackPhone));
//        body.put("channel_code",jsonObject.getString("channelCode"));
//        body.put("channel_secret_key",jsonObject.getString("channelSecretKey"));
//        //主体
//        httpApiConfig.setContent(JSONObject.toJSONString(body));
        httpApiConfig.setContent("");
        JSONObject resultObj=new  JSONObject();
        KeyValueObject status=new KeyValueObject();
        status.setType("spel");
        status.setValue("#root[status]==200?0:1");
//        List<FunctionObject> functionObjects = Lists.newArrayList();
//        FunctionObject functionObject = new FunctionObject();
//        functionObject.setCode("resultCodeConvertStatusInteger");
//        functionObjects.add(functionObject);
//        status.setFunctions(functionObjects);
        resultObj.put("status","#"+JSONObject.toJSONString(status));
        httpApiConfig.setResult(JSONObject.toJSONString(resultObj));
        String jsonString = JSONObject.toJSONString(httpApiConfig);
        log.info("Gexinjinfu api {}",jsonString);
        return httpApiConfig;
    }

    /**
     * @description:  快亿贷 api配置
     * @param:
     * @return:
     * @author zhangyy
     * @date: 2024/9/9 18:06
     */
    public void generateKuaiyidaiConfig(String openApiConfig) {
        EgApiDo egApiDo=new EgApiDo();
        egApiDo.setApiCode("EG:"+ BusinessPrefixEnum.CHECK_INTO_PREFIX.getCode()+":Kuaiyidai");
        egApiDo.setApiName(BusinessPrefixEnum.CHECK_INTO_PREFIX.getMsg());
        egApiService.save(egApiDo);
        JSONObject jsonObject = JSONObject.parseObject(openApiConfig);
        EgApiEndpointDo egApiEndpointDo=new EgApiEndpointDo();
        egApiEndpointDo.setApiId(egApiDo.getId());
        egApiEndpointService.save(egApiEndpointDo);
    }

    private HttpApiConfig createKuaiyidaiCheckIntoBean(String openApiConfig) {
        JSONObject jsonObject=JSONObject.parseObject(openApiConfig);
        HttpApiConfig httpApiConfig = new HttpApiConfig();
        httpApiConfig.setUrl(jsonObject.getString("url")+"/Admin/UserIncomeApi/comparePhoneMonitor");
        httpApiConfig.setMethod("POST");
        httpApiConfig.setContentType(ApiPayloadTypeEnum.APPLICATION_X_WWW_FORM_URLENCODED.getCode());
        List<KeyValueObject> headers = Lists.newArrayList();
        KeyValueObject head=new KeyValueObject();
        head.setType(ValueObjectTypeEnum.BASIC.getType());
        head.setKey("Content-Type");
        head.setValue("application/x-www-form-urlencoded; charset=UTF-8");
        headers.add(head);
        httpApiConfig.setHeader(headers);
//        List<KeyValueObject> search = Lists.newArrayList();
//        KeyValueObject searchKey=new KeyValueObject();
//        searchKey.setType(ValueObjectTypeEnum.SPEL.getType());
//        searchKey.setKey("mobnum_md5");
//        searchKey.setValue("#param.user.phoneMd5");
//        search.add(searchKey);
//        httpApiConfig.setSearch(search);
        JSONObject body=new  JSONObject();
        body.put("qdName",jsonObject.getString("qdName"));
        KeyValueObject attackPhone=new KeyValueObject();
        attackPhone.setType("spel");
        attackPhone.setValue("#param.user.phoneMd5");
        body.put("phone","#"+JSONObject.toJSONString(attackPhone));
        KeyValueObject city=new KeyValueObject();
        city.setType("spel");
        city.setValue("#param.user.cityAllName");
        body.put("city","#"+JSONObject.toJSONString(city));

        //主体
        httpApiConfig.setContent(JSONObject.toJSONString(body));
        httpApiConfig.setContent("");
        JSONObject resultObj=new  JSONObject();
        KeyValueObject status=new KeyValueObject();
        status.setType("spel");
        status.setValue("#root[status]==200?0:1");
//        List<FunctionObject> functionObjects = Lists.newArrayList();
//        FunctionObject functionObject = new FunctionObject();
//        functionObject.setCode("resultCodeConvertStatusInteger");
//        functionObjects.add(functionObject);
//        status.setFunctions(functionObjects);
        resultObj.put("status","#"+JSONObject.toJSONString(status));
        httpApiConfig.setResult(JSONObject.toJSONString(resultObj));
        String jsonString = JSONObject.toJSONString(httpApiConfig);
        log.info("Kuaiyidai api {}",jsonString);
        return httpApiConfig;
    }
}
