package com.hrsk.cloud.eg.app.route.impl;

import com.alibaba.fastjson2.JSONObject;
import com.hrsk.cloud.eg.app.loan.executor.checkInto.CheckCmdExe;
import com.hrsk.cloud.eg.app.route.EndpointRouteService;
import com.hrsk.cloud.eg.clinet.dto.data.command.ApiInvokeParamCmd;
import com.hrsk.cloud.eg.clinet.dto.data.command.LoanParamCmd;
import com.hrsk.cloud.eg.clinet.dto.data.plan.command.EgLoanApiConfigInfoCmd;
import com.hrsk.cloud.eg.domain.common.constant.egress.EgRouteTypeEnum;
import com.hrsk.cloud.eg.infrastructure.repository.database.entity.EgLoanApiConfigInfoDo;
import com.hrsk.cloud.eg.infrastructure.service.EgApiService;
import com.hrsk.cloud.eg.infrastructure.utils.BeanCopyUtils;
import com.hrsk.pangu.dto.SingleResponse;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author zhangyy
 * @version 1.0
 * @description: CheckIntoCmd
 * @date 2024/11/6 16:29
 */
@Service
public class CheckIntoCmd implements EndpointRouteService {

    @Resource
    private EgApiService egApiService;

    @Resource
    private List<CheckCmdExe> checkCmdExeList;

    @Override
    public SingleResponse apiEndPoint(ApiInvokeParamCmd apiInvokeParamCmd) {
        LoanParamCmd checkIntoParamCmd = JSONObject.parseObject(apiInvokeParamCmd.getParam().toString(), LoanParamCmd.class);
        EgLoanApiConfigInfoDo loanApiConfigInfo = egApiService.getLoanApiConfigInfo(checkIntoParamCmd.getPlan().getApiId());
        EgLoanApiConfigInfoCmd configCmd = BeanCopyUtils.copy(loanApiConfigInfo, EgLoanApiConfigInfoCmd.class);
        Map<String, CheckCmdExe> collect = checkCmdExeList.stream().collect(Collectors.toMap(CheckCmdExe::getMode, CheckCmdExe -> CheckCmdExe));

        return   collect.get(loanApiConfigInfo.getIntegrationMode()).route(checkIntoParamCmd);
    }

    @Override
    public String getRoute() {
        return EgRouteTypeEnum.CHECK_INTO.getCode();
    }
}
