package com.hrsk.cloud.eg.clinet.constant;

/**
 * @author zhangyy
 * @version 1.0
 * @description: GlobalDataStatus 全局数据标识是否有效的数据
 * @date 2024/8/28 14:05
 */
public enum GlobalDataStatusEnum {
    YES("Y","有效"),
    NO("N","无效");
    private String code;
    private String msg;

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

     GlobalDataStatusEnum (String code,String msg) {
        this.code = code;
        this.msg = msg;
    }

    /** 
     * @description: 获取code
     * @param:  
     * @return:  
     * @author zhangyy
     * @date: 2024/8/28 14:51
     */ 
    public static GlobalDataStatusEnum getByCode(String code) {
        for (GlobalDataStatusEnum dataStatus : values()) {
            if (dataStatus.getCode().equals(code)) {
                return dataStatus;
            }
        }
        return null;
    }

    /** 
     * @description: 获取描述信息
     * @param:  
     * @return:  
     * @author zhangyy
     * @date: 2024/8/28 14:50
     */ 
    public static String getByMsg(String code) {
        for (GlobalDataStatusEnum globalDataStatusEnum : values()) {
            if (globalDataStatusEnum.getCode().equals(code)) {
                return globalDataStatusEnum.getMsg();
            }
        }
        return null;
    }

}
