package com.hrsk.cloud.eg.clinet.dto.data.user.command;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 信贷经理房产情况表
 * </p>
 *
 * @author zhangyy
 * @since 2019-09-29
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class UserAssetHouseInfoCmd implements Serializable {


    private Integer id;

    private Long userId;

    /**
     * 房产情况 1.商品住宅 2.无房产 3.商铺 4.办公楼 5.厂房 6.经济适用房/限价房 7.房改/危改房 8.小产权房 9.宅基地/自建房 10.军改房 11.商住两用房 12.有房可抵押,13:有房不抵押
     * */
    private Integer houseType;

    /**
     * 估值 1.50万以下 2.100万 3.200万 4.300万 5.500万 6.1000万以上
     * */
    private Integer appeasement;


    /**
     * 房产年限 1.10年以下 2.10-20年 3.20-25年 4.25-30年 5.30年以上
     * */
    private Integer houseLimit;

    /**
     * 是否接受抵押 1. 不接受抵押 2. 可以抵押
     * */
    private Integer spawn;

    private Date createTime;

    private String createBy;

    private Date updateTime;

    private String updateBy;


}
