package com.hrsk.cloud.eg.clinet.dto.data.user.command;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 信贷经理职业-企业主信息表
 * </p>
 *
 * @author zhangyy
 * @since 2019-09-29
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class UserProfessionBusinessOwnerCmd implements Serializable {


    private Integer id;

    private Long userId;

    /**
     * 企业类型 1.微小型企业一年收入500万以下 2.中小企业一年收入500万-5000万 3.大型企业一年收入5000万以上
     * */
    private Integer companyType;

    /**
     * 企业名称
     * */
    private String companyName;

    /**
     * 企业对公流水 1.5万以下 2.5万-30万 3.30万-100万 4.100万-1000万 5.1000万以上
     * */
    private String companyCommWater;

    /**
     * 企业对私流水 1.1万以下2.1万-5万3.5万-20万4.20万-100万5.100万以上
     * */
    private String companyPrivateWater;

    /**
     * 经营年限 1.6个月以内 2.6-12月 3.1-3年 4.3-5年 5.5年以上
     * */
    private Integer workingLimit;

    /**
     * 经营执照 1.没办理 2.已办理，注册1年以内 3.已办理，注册满1年 4.已办理，注册满2年 5.已办理，注册满3年 6.已办理，注册满4年 7.已办理，注册满5年以上
     * */
    private Integer businessLicense;

    private Date createTime;

    private String createBy;

    private Date updateTime;

    private String updateBy;

    /**
     * 月收入
     * */
    private String monthlyBillingIncome;

    /**
     * 类型 0：企业主 1：工商老板 2， 企业法人
     * */
    private Integer type;


}
