package com.hrsk.cloud.eg.clinet.dto.data.user.command;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 信贷经理职业-个体户信息表
 * </p>
 *
 * @author zhangyy
 * @since 2019-09-29
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class UserProfessionSelfEmployedCmd implements Serializable {


    private Integer id;

    private Long userId;

    /**
     * "经营年限 " +
     *             " 1.6个月以内  2.6-12月  3.1-3年  4.3-5年  5.5年以上"
     */
    private Integer workingLimit;

    /**
     * "月度营业额  " +
     *             "1.1000以下 2.1000-3000 3.3000-8000 4.8000-20000 5.20000-50000" +
     *             " 6.50000-100000 7.100000以上"
     */
    private Integer turnover;

    /**
     *"是否有营业执照 " +
     *             "1.没办理 2.已办理，注册1年以内 3.已办理，注册满1年 " +
     *             "4.已办理，注册满2年 5.已办理，注册满3年" +
     *             " 6.已办理，注册满4年 7.已办理，注册满5年以上"
     */
    private Integer businessLicense;

    /**
     *"pos机使用流水 1.无pos机 2.5万以下 3.5万-30万" +
     *             " 4.30万-100万 5.100万-1000万 6.1000万以上"
     */
    private Integer posUseMoney;

    /**
     *"pos机使用年限 " +
     *             "1.无pos机 2.6个月以内 3.6-12月 4.1-3年 5.3-5年 6.5年以上"
     */
    private Integer posUseLimit;

    private Date createTime;

    private String createBy;

    private Date updateTime;

    private String updateBy;

    private Integer monthlyBillingIncome;

    private Integer merchantType;




}
