package com.hrsk.cloud.eg.domain.api;

import lombok.Getter;
import lombok.experimental.Accessors;
import org.springframework.expression.spel.support.StandardEvaluationContext;

/**
 * @author: bianlanzhou
 * @create: 2024-07-31 11:48
 * @description: API上下文
 **/
@Getter
@Accessors(chain = true)
public class ApiContext {
    /**
     * 入参
     */
    private final Object input;
    /**
     * spel context
     */
    private final StandardEvaluationContext spelContext = new StandardEvaluationContext();
    /**
     * 构造函数
     * @param input 入参
     */
    public ApiContext(Object input) {
        this.input = input;
        spelContext.setVariable("param",input);
    }
}
