package com.hrsk.cloud.eg.domain.api;

import com.google.common.collect.Lists;
import com.hrsk.cloud.eg.domain.api.func.ValueObjectFunctionManager;
import com.hrsk.cloud.eg.domain.api.resolver.vo.ValueObjectResolverManager;
import lombok.Data;
import lombok.ToString;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

/**
 * @author: bianlanzhou
 * @create: 2024-07-27 11:05
 * @description: 函数对象,值对象
 **/
@ToString
@Data
public class FunctionObject implements Serializable {
    /**
     * 编码
     */
    private String code;
    /**
     * 参数
     */
    private List<ValueObject> args = Lists.newArrayList();

    /**
     * 执行
     */
    public Object apply(Object value,ApiContext apiContext){
        FunctionParam functionParam = new FunctionParam().setInput(value);
        for(ValueObject arg : args){
            functionParam.getExtArg().add(ValueObjectResolverManager.getInstance().resolve(arg,apiContext));
        }
        return ValueObjectFunctionManager.getInstance().apply(code,functionParam);
    }

    public Object apply(Object value, Map<String,Object> apiContext){
        FunctionParam functionParam = new FunctionParam().setInput(value);
        for(ValueObject arg : args){
            functionParam.getExtArg().add(ValueObjectResolverManager.getInstance().resolve(arg,apiContext));
        }
        return ValueObjectFunctionManager.getInstance().apply(code,functionParam);
    }
}
