package com.hrsk.cloud.eg.domain.api;

import com.google.common.collect.Lists;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.List;

/**
 * @author: bianlanzhou
 * @create: 2024-07-31 15:47
 * @description: HTTP API配置
 **/
@EqualsAndHashCode(callSuper = true)
@Data
@Accessors(chain = true)
public class HttpApiConfig extends ApiConfig implements Serializable {
    /**
     * 请求方法
     */
    private String method;
    /**
     * url地址 http://baidu.com /a/b/c
     */
    private String url;
    /**
     * header
     */
    private List<KeyValueObject> header = Lists.newArrayList();
    /**
     * path  a/b/b
     */
    private List<ValueObject> path = Lists.newArrayList();
    /**
     * search
     */
    private List<KeyValueObject> search = Lists.newArrayList();
    /**
     * 内容类型
     */
    private String contentType;
    /**
     * body
     */
    private String content;

    /**
     * result 返回处理
     */
    private String resultHandle;

     /**
     * result 返回值
     */
    private String result;



}
