package com.hrsk.cloud.eg.domain.api;

import com.hrsk.cloud.eg.domain.common.utils.BizPreconditions;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;
import org.apache.commons.lang3.StringUtils;

/**
 * @author: bianlanzhou
 * @create: 2024-07-31 16:14
 * @description: kv对象
 **/
@ToString
@EqualsAndHashCode(callSuper = true)
@Data
public class KeyValueObject extends ValueObject {
    /**
     * key
     */
    private String key;
    /**
     * 校验必要参数
     */
    void checkParam(){
        super.checkParam();
        BizPreconditions.checkArgument(StringUtils.isEmpty(key),"配置中值对象的key不能为空!");
    }
}
