package com.hrsk.cloud.eg.domain.api.common;

import com.google.common.collect.Lists;
import lombok.Getter;

import java.util.ArrayList;
import java.util.List;

/**
 * @author zhangyy
 * @version 1.0
 * @description: ThreeplatfromResultCodeEnum 对接api或者平台 成功的返回值用来
 * @date 2024/9/5 13:52
 */
@Getter
public enum ThreeplatfromResultCodeEnum {
    ONE(200,""),
    TWO(400,""),
    THREE(1,""),
;
    private Integer code;
    private String msg;

    ThreeplatfromResultCodeEnum(Integer code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public static ThreeplatfromResultCodeEnum getByCode(Integer code) {
        for (ThreeplatfromResultCodeEnum result : ThreeplatfromResultCodeEnum.values()) {
            if (result.getCode().equals(code)) {
                return result;
            }
        }
        return null;
    }

    public static List<Integer> getList() {
        List<Integer> result = Lists.newArrayList();
        for (ThreeplatfromResultCodeEnum code : ThreeplatfromResultCodeEnum.values()) {
            result.add(code.getCode());
        }
        return result;
    }
}
