package com.hrsk.cloud.eg.domain.api.resolver.vo;


import com.hrsk.cloud.eg.domain.api.ApiContext;
import com.hrsk.cloud.eg.domain.api.ApiResult;
import com.hrsk.cloud.eg.domain.api.ValueObject;

import java.util.Map;

/**
 * @author: bianlanzhou
 * @create: 2024-07-31 14:32
 * @description: 值对象解析器
 **/
public interface ValueObjectResolver {
    /**
     * 解析
     * @param valueObject 解析对象
     * @param context 上下文
     * @return 解析结果
     */
    Object resolve(ValueObject valueObject, ApiContext context);

    /**
     * 解析
     * @param valueObject 解析对象
     * @param context 上下文
     * @return 解析结果
     */
    Object resolve(ValueObject valueObject, Map<String,Object> context);
}

