package com.hrsk.cloud.eg.domain.common.constant;

import lombok.Getter;

import java.util.HashMap;
import java.util.Map;

/**
 * @author zhangyy
 * @version 1.0
 * @description: BusinessServiceEnums
 * @date 2024/11/6 16:00
 */
@Getter
public enum BusinessServiceEnums {

    ACCESS_DENIED("100009","您没有当前操作权限!"),
    CAPTCHA_NOT_MATCH("100008","验证码错误!"),
    NOT_LOGIN("100007","尚未登录，请先登录!"),
    OTP_NOT_MATCH("100006","验证码错误!"),
    USER_PASSWORD_RETRY_LIMIT_EXCEED("100005","用户密码重试超过最大次数!"),
    USER_HAS_DEACTIVATED("100004","用户已经被停用!"),
    USER_HAS_DELETED("100003","用户已经被删除!"),
    PASSWORD_NOT_MATCH("100002","用户名密码不匹配!"),
    USER_NOT_FOUND("100001","用户不存在!"),
    OK("000000","操作成功!"),
    FAIL("-999999","操作失败!");


    ;


    private String code;
    private String message;

    static Map<String, BusinessServiceEnums> map = new HashMap();

    static {
        for (BusinessServiceEnums value : BusinessServiceEnums.values()) {
            map.put(value.code, value);
        }
    }

    BusinessServiceEnums(String number, String message) {
        this.code = number;
        this.message = message;
    }

    public static BusinessServiceEnums getByCode(String code) {
        return map.get(code);
    }
}
