package com.hrsk.cloud.eg.domain.common.constant;

public enum ResultCode {
    // 全局
    NO_LOGIN(-10,"未登录","未登录"),
    GLOBAL_REQUEST_OK(0,"请求成功标志","请求成功"),
    GLOBAL_REQUEST_FAIL(1,"请求失败标志","请求失败"),
    GLOBAL_PARAM_MISSING(6,"全局参数缺失","不能为空"),
    GLOBAL_VERIFICATION_ERROR(7,"验证码错误","验证码错误"),
    GLOBAL_NOT_LOGIN(-130,"未登录标志","请先登录"),
    GLOBAL_MISS_TOKEN(-130,"token缺失","请先登录"),
    INFO_DOCUMENT_LIST(300,"暂无素材信息","暂无素材信息"),
    INFO_FQA_LIST(310,"暂无问答信息","暂无问答信息"),
    INFO_MSG_LIST(320,"暂无消息信息","暂无消息信息"),
    INFO_USERFEEDBACK_LIST(340,"暂无意见反馈信息","暂无意见反馈信息"),
    INFO_APPVERSIONLOG_LIST(350,"暂无APP更新日志信息","暂无APP更新日志信息"),
    INFO_APPVERSION_LIST(330,"暂无版本更新信息","暂无版本更新信息"),
    THIRDSERVER_REQUEST_EXCEPTION(100,"第三方接口连接异常","第三方接口连接异常"),
    THIRDSERVER_RESPONSE_EXCEPTION(100,"第三方接口返回数据异常","第三方接口返回数据异常"),
    OTHER_DATATYPE_FAIL(94,"数据类错误","数据类型错误"),
    SYSTEM_EXCEPTION(999,"系统异常，请稍后再试","系统异常，请稍后再试"),
    GLOBAL_REAL_EXISTS(201,"身份证已经被实名","请求失败"),
    GLOBAL_REAL_MISMATCH(202,"姓名与身份证号不匹配","请求失败"),
    GLOBAL_REAL_SERVICE(203,"实名认证接口异常","请求失败"),
    GLOBAL_REAL_LOCK(204,"密码错误超过三次","密码输出错误锁定5分钟，请稍后再试"),
    GLOBAL_GO_VERIFYSMS_LOGIN(205,"短信验证登录","短信验证登录"),
    GLOBAL_INTERFACE_LIMIT(206,"接口访问频繁","接口访问太过频繁，请稍后再试")
    ;
    private final int code;
    private final String description;
    private final String msg;

    ResultCode(int code, String description, String msg) {
        this.code = code;
        this.description = description;
        this.msg = msg;
    }

    public int getCode() {
        return code;
    }

    public String getMsg() {
        return msg;
    }

    public String getDescription() {
        return description;
    }


}
