package com.hrsk.cloud.eg.domain.common.constant.egress;

import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.HashMap;
import java.util.Map;

/**
 * @author zhangyy
 * @version 1.0
 * @description: EgApiTypeEnum
 * @date 2024/9/23 13:58
 */
@Getter
@AllArgsConstructor
public enum EgApiTypeEnum {
    LOAN_API("LOAN_API","助贷api"),
    INTERBANK_API("INTERBANK_API","同业api"),
    FAST_LOAN("FAST_LOAN","极速贷api")

    ;
    static Map<String, EgApiTypeEnum> map = new HashMap();

    static {
        for (EgApiTypeEnum value : EgApiTypeEnum.values()) {
            map.put(value.code, value);
        }
    }

    public static EgApiTypeEnum getByCode(String code) {
        return map.get(code);
    }
    private String code;

    private String msg;

    public String getCode() {
        return code;
    }

    public String getMsg() {
        return msg;
    }
}
