package com.hrsk.cloud.eg.domain.common.constant.egress;

import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.HashMap;
import java.util.Map;

/**
 * @author zhangyy
 * @version 1.0
 * @description: EgApiTypeEnum
 * @date 2024/9/23 13:58
 */
@Getter
@AllArgsConstructor
public enum EgRouteTypeEnum {
    CHECK_INTO("CHECK_INTO","准入"),
    APPLY("APPLY","注册"),

    ;
    static Map<String, EgRouteTypeEnum> map = new HashMap();

    static {
        for (EgRouteTypeEnum value : EgRouteTypeEnum.values()) {
            map.put(value.code, value);
        }
    }

    public static EgRouteTypeEnum getByCode(String code) {
        return map.get(code);
    }
    private String code;

    private String msg;

    public String getCode() {
        return code;
    }

    public String getMsg() {
        return msg;
    }
}
