package com.hrsk.cloud.eg.infrastructure.config;

import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import com.hrsk.cloud.eg.clinet.constant.GlobalDataStatusEnum;
import com.hrsk.cloud.eg.infrastructure.utils.SnowflakeIdWorker;
import com.hrsk.cloud.eg.infrastructure.repository.database.entity.BaseDo;
import org.apache.ibatis.reflection.MetaObject;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.Objects;

/**
 * @description: mybatis 默认meta数据填充
 * @author zhangyy
 * @date: 2024/8/28 14:30
 */
@Component
public class MyMetaObjectHandler implements MetaObjectHandler {
    @Override
    public void insertFill(MetaObject metaObject) {
//        注释的这种方式只是填充了id和状态
     //this.strictInsertFill(metaObject,"create_uid",String.class, String.valueOf(SnowflakeIdWorker.nextId()));
        try {
            //时间格式的时候不能填充所以使用了这种方式。
            BaseDo baseDO = (BaseDo) metaObject.getOriginalObject();
            // 插入操作时的自动填充逻辑
            if (Objects.isNull(baseDO.getId())) {
                baseDO.setId(SnowflakeIdWorker.nextId());
            }
            baseDO.setStatus(GlobalDataStatusEnum.YES.getCode());
            baseDO.setGmtModify(new Date());
            baseDO.setGmtCreate(new Date());
            baseDO.setModifyUsername("");
            baseDO.setCreateUsername("");
//            baseDO.setCreateUid(String.valueOf(baseDO.getId()));
        } catch (Exception e) {
            //不处理
        }
    }

    @Override
    public void updateFill(MetaObject metaObject) {
        // 更新操作时的自动填充逻辑
        try {
            BaseDo baseDo = (BaseDo) metaObject.getOriginalObject();
            baseDo.setGmtModify(new Date());
        } catch (Exception e) {
            //不处理
        }
    }

}