package com.hrsk.cloud.eg.infrastructure.config.client;

import com.hrsk.cloud.eg.domain.api.HttpApi;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Component;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;

import javax.annotation.Resource;
import java.util.Map;
import java.util.Objects;
/**
 * @author: bianlanzhou
 * @create: 2024-08-02 17:08
 * @description: http请求客户端
 **/
@Slf4j
@Component
public class HttpTemPlateClient {
    @Resource
    private RetryRestTemplate httpRestTemplate;
    /**
     * 请求
     * @param httpApi http api对象
     * @return 响应数据
     */
    public Object request(HttpApi httpApi){
        ResponseEntity<String> responseEntity = null;
        //补充headers
        MultiValueMap<String, String> headers = new LinkedMultiValueMap<>();
        if(!httpApi.getHeader().isEmpty()){
          Map<String,Object> orgMap=httpApi.getHeader();
            for (String key : orgMap.keySet()) {
                headers.add(key, orgMap.get(key).toString());
            }
        }
        try {
            responseEntity = httpRestTemplate.restTemplate().exchange(httpApi.getUrl(),
                    Objects.requireNonNull(HttpMethod.resolve(httpApi.getMethod())),
                    new HttpEntity<>(httpApi.getPayload(),new HttpHeaders(headers))
                    ,
                    String.class);
        } catch (Exception e) {
            log.error("请求异常,请求数据:[{}].", httpApi.toString() ,e);
        }
        return responseEntity ==null?null:responseEntity.getBody();
    }
}
