package com.hrsk.cloud.eg.infrastructure.config.redis;


import org.springframework.data.redis.serializer.StringRedisSerializer;

/**
 * @author zhangyy
 * @version 1.0
 * @description: PrefixRedisSerializer
 * @date 2024/9/10 13:50
 */
public class PrefixRedisSerializer extends StringRedisSerializer {
    public static final String DEFUAL_PREFIX = "eg:";
    @Override
    public byte[] serialize(String s) {
        if (s == null) {
            return null;
        }
        // 这里加上你需要加上的key前缀
        String realKey = DEFUAL_PREFIX + s;
        return super.serialize(realKey);
    }
    @Override
    public String deserialize(byte[] bytes) {
        String s = bytes == null ? null : new String(bytes);
        int index = s.indexOf(DEFUAL_PREFIX);
        if (index != -1) {
            return s.substring(index + 2);
        }
        return s;
    }

}
