package com.hrsk.cloud.eg.infrastructure.loanMannager.threedocking.impl;

import com.alibaba.fastjson2.JSONObject;
import com.hrsk.cloud.eg.clinet.dto.data.plan.command.EgLoanApiConfigInfoCmd;
import com.hrsk.cloud.eg.clinet.dto.data.plan.command.PlanCmd;
import com.hrsk.cloud.eg.clinet.dto.data.user.command.UserBaseInfoCmd;
import com.hrsk.cloud.eg.clinet.vo.DataVo;
import com.hrsk.cloud.eg.domain.common.constant.ServerCodeEnums;
import com.hrsk.cloud.eg.infrastructure.config.client.HessianUtils;
import com.hrsk.cloud.eg.infrastructure.config.client.RetryRestTemplate;
import com.hrsk.cloud.eg.infrastructure.loanMannager.threedocking.LoanDockingApi;
import com.hrsk.cloud.eg.infrastructure.service.EgApiService;
import com.hrsk.cloud.eg.infrastructure.utils.DateUtil;
import com.hrsk.cloud.eg.infrastructure.utils.Md5Util;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.HttpResponse;
import org.apache.http.util.EntityUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.Date;
import java.util.HashMap;


/**
 * 东方融资网
 *
 * @author caixiaofan
 * @create 2020/3/31
 * @since 1.0.0
 */
@Deprecated
@Component
@Slf4j
public class DfrzwCreditService implements LoanDockingApi {

    private static final String citys = "北京市,BEIJING|天津市,TIANJIN|上海市,SHANGHAI|重庆市,CHONGQING|邯郸市,HANDAN|石家庄市,SHIJIAZHUANG|保定市,BAODING|张家口市,ZHANGJIAKOU|承德市,CHENGDE|唐山市,TANGSHAN|廊坊市,LANGFANG|沧州市,CANGZHOU|衡水市,HENGSHUI|邢台市,XINGTAI|秦皇岛市,QINHUANGDAO|朔州市,SHUOZHOU|忻州市,XINZHOU|太原市,TAIYUAN|大同市,DATONG|阳泉市,YANGQUAN|晋中市,JINZHONG|长治市,CHANGZHI|晋城市,JINCHENG|临汾市,LINFEN|吕梁市,LVLIANG|运城市,YUNCHENG|沈阳市,SHENYANG|铁岭市,TIELING|大连市,DALIAN|鞍山市,ANSHAN|抚顺市,FUSHUN|本溪市,BENXI|丹东市,DANDONG|锦州市,JINZHOU|营口市,YINGKOU|阜新市,FUXIN|辽阳市,LIAOYANG|朝阳市,CHAOYANG|盘锦市,PANJIN|葫芦岛市,HULUDAO|长春市,CHANGCHUN|吉林市,JILIN|延边朝鲜族自治州,YANBIAN|四平市,SIPING|通化市,TONGHUA|白城市,BAICHENG|辽源市,LIAOYUAN|松原市,SONGYUAN|白山市,BAISHAN|哈尔滨市,HAERBIN|齐齐哈尔市,QIQIHAER|鸡西市,JIXI|牡丹江市,MUDANJIANG|七台河市,QITAIHE|佳木斯市,JIAMUSI|鹤岗市,HEGANG|双鸭山市,SHUANGYASHAN|绥化市,SUIHUA|黑河市,HEIHE|大兴安岭地区,DAXINGANLING|伊春市,YICHUNSHI|大庆市,DAQING|南京市,NANJING|无锡市,WUXI|镇江市,ZHENJIANG|苏州市,SUZHOU|南通市,NANTONG|扬州市,YANGZHOU|盐城市,YANCHENG|徐州市,XUZHOU|淮安市,HUAIAN|连云港市,LIANYUNGANG|常州市,CHANGZHOU|泰州市,TAIZHOU|宿迁市,SUQIAN|舟山市,ZHOUSHAN|衢州市,QUZHOU|杭州市,HANGZHOU|湖州市,HUZHOU|嘉兴市,JIAXING|宁波市,NINGBO|绍兴市,SHAOXING|温州市,WENZHOU|丽水市,LISHUI|金华市,JINHUA|台州市,TAIZHOU1|合肥市,HEFEI|芜湖市,WUHU|蚌埠市,BENGBU|淮南市,HUAINAN|马鞍山市,MAANSHAN|淮北市,HUAIBEI|铜陵市,TONGLING|安庆市,ANQING|黄山市,HUANGSHAN|滁州市,CHUZHOU|阜阳市,FUYANG|宿州市,SUZHOU1|六安市,LIUAN|亳州市,BOZHOU|池州市,CHIZHOU|宣城市,XUANCHENG|福州市,FUZHOU|厦门市,XIAMEN|宁德市,NINGDE|莆田市,PUTIAN|泉州市,QUANZHOU|漳州市,ZHANGZHOU|龙岩市,LONGYAN|三明市,SANMING|南平市,NANPING|鹰潭市,YINGTAN|新余市,XINYU|南昌市,NANCHANG|九江市,JIUJIANG|上饶市,SHANGRAO|抚州市,FUZHOU1|宜春市,YICHUN|吉安市,JIAN|赣州市,GANZHOU|景德镇市,JINGDEZHEN|萍乡市,PINGXIANG|菏泽市,HEZE|济南市,JINAN|青岛市,QINGDAO|淄博市,ZIBO|德州市,DEZHOU|烟台市,YANTAI|潍坊市,WEIFANG|济宁市,JINING|泰安市,TAIAN|临沂市,LINYI|滨州市,BINZHOU|东营市,DONGYING|威海市,WEIHAI|枣庄市,ZAOZHUANG|日照市,RIZHAO|莱芜市,LAIWU|聊城市,LIAOCHENG|商丘市,SHANGQIU|郑州市,ZHENGZHOU|安阳市,ANYANG|新乡市,XINXIANG|许昌市,XUCHANG|平顶山市,PINGDINGSHAN|信阳市,XINYANG|南阳市,NANYANG|开封市,KAIFENG|洛阳市,LUOYANG|济源市,JIYUAN|焦作市,JIAOZUO|鹤壁市,HEBI|濮阳市,PUYANG|周口市,ZHOUKOU|漯河市,LUOHE|驻马店市,ZHUMADIAN|三门峡市,SANMENXIA|武汉市,WUHAN|襄阳市,XIANGFAN|鄂州市,EZHOU|孝感市,XIAOGAN|黄冈市,HUANGGANG|黄石市,HUANGSHI|咸宁市,XIANNING|荆州市,JINGZHOU|宜昌市,YICHANG|恩施土家族苗族自治州,ENSHI|神农架林区,SHENNONGJIA|十堰市,SHIYAN|随州市,SUIZHOU|荆门市,JINGMEN|仙桃市,XIANTAO|天门市,TIANMEN|潜江市,QIANJIANG|岳阳市,YUEYANG|长沙市,CHANGSHA|湘潭市,XIANGTAN|株洲市,ZHUZHOU|衡阳市,HENGYANG|郴州市,CHENZHOU|常德市,CHANGDE|益阳市,YIYANG|娄底市,LOUDI|邵阳市,SHAOYANG|湘西土家族苗族自治州,XIANGXI|张家界市,ZHANGJIAJIE|怀化市,HUAIHUA|永州市,YONGZHOU|广州市,GUANGZHOU|汕尾市,SHANWEI|阳江市,YANGJIANG|揭阳市,JIEYANG|茂名市,MAOMING|惠州市,HUIZHOU|江门市,JIANGMEN|韶关市,SHAOGUAN|梅州市,MEIZHOU|汕头市,SHANTOU|深圳市,SHENZHEN|珠海市,ZHUHAI|佛山市,FOSHAN|肇庆市,ZHAOQING|湛江市,ZHANJIANG|中山市,ZHONGSHAN|河源市,HEYUAN|清远市,QINGYUAN|云浮市,YUNFU|潮州市,CHAOZHOU|东莞市,DONGGUAN|兰州市,LANZHOU|金昌市,JINCHANG|白银市,BAIYIN|天水市,TIANSHUI|嘉峪关市,JIAYUGUAN|武威市,WUWEI|张掖市,ZHANGYE|平凉市,PINGLIANG|酒泉市,JIUQUAN|庆阳市,QINGYANG|定西市,DINGXI|陇南市,LONGNAN|临夏回族自治州,LINXIA|甘南藏族自治州,GANNAN|成都市,CHENGDU|攀枝花市,PANZHIHUA|自贡市,ZIGONG|绵阳市,MIANYANG|南充市,NANCHONG|达州市,DAZHOU|遂宁市,SUINING|广安市,GUANGAN|巴中市,BAZHONG|泸州市,LUZHOU|宜宾市,YIBIN|资阳市,ZIYANG|内江市,NEIJIANG|乐山市,LESHAN|眉山市,MEISHAN|凉山彝族自治州,LIANGSHAN|雅安市,YAAN|甘孜藏族自治州,GANZI|阿坝藏族羌族自治州,ABA|德阳市,DEYANG|广元市,GUANGYUAN|贵阳市,GUIYANG|遵义市,ZUNYI|安顺市,ANSHUN|黔南布依族苗族自治州,QIANNAN|黔东南苗族侗族自治州,QIANDONGNAN|铜仁市,TONGREN|毕节市,BIJIEDIQU|六盘水市,LIUPANSHUI|黔西南布依族苗族自治州,QIANXINAN|海口市,HAIKOU|三亚市,SANYA|五指山市,WUZHISHAN|琼海市,QIONGHAI|儋州市,DANZHOU|文昌市,WENCHANG|万宁市,WANNING|东方市,DONGFANG|澄迈县,CHENGMAIXIAN|定安县,DINGANXIAN|屯昌县,TUNCHANGXIAN|临高县,LINGAOXIAN|白沙黎族自治县,BAISHA|昌江黎族自治县,CHANGJIANG|乐东黎族自治县,LEDONG|陵水黎族自治县,LINGSHUI|保亭黎族苗族自治县,BAOTING|琼中黎族苗族自治县,QIONGZHONG|西双版纳傣族自治州,XISHUANGBANNA|德宏傣族景颇族自治州,DEHONG|昭通市,ZHAOTONG|昆明市,KUNMING|大理白族自治州,DALI|红河哈尼族彝族自治州,HONGHE|曲靖市,QUJING|保山市,BAOSHAN|文山壮族苗族自治州,WENSHAN|玉溪市,YUXI|楚雄彝族自治州,CHUXIONG|普洱市,PUER|临沧市,LINCANG|怒江傈僳族自治州,NUJIANG|迪庆藏族自治州,DIQING|丽江市,LIJIANG|海北藏族自治州,HAIBEI|西宁市,XINING|海东市,HAIDONG|黄南藏族自治州,HUANGNAN|海南藏族自治州,HAINAN|果洛藏族自治州,GUOLUO|玉树藏族自治州,YUSHU|海西蒙古族藏族自治州,HAIXI|西安市,XIAN|咸阳市,XIANYANG|延安市,YANAN|榆林市,YULIN1|渭南市,WEINAN|商洛市,SHANGLUO|安康市,ANKANG|汉中市,HANZHONG|宝鸡市,BAOJI|铜川市,TONGCHUAN|防城港市,FANGCHENGGANG|南宁市,NANNING|崇左市,CHONGZUO|来宾市,LAIBIN|柳州市,LIUZHOU|桂林市,GUILIN|梧州市,WUZHOU|贺州市,HEZHOU|贵港市,GUIGANG|玉林市,YULIN|百色市,BAISE|钦州市,QINZHOU|河池市,HECHI|北海市,BEIHAI|拉萨市,LASA|日喀则市,RIKAZE|山南市,SHANNAN|林芝市,LINZHI|昌都市,CHANGDU|那曲市,NAQU|阿里地区,ALI|银川市,YINCHUAN|石嘴山市,SHIZUISHAN|吴忠市,WUZHONG|固原市,GUYUAN|中卫市,ZHONGWEI|塔城地区,TACHENG|哈密市,HAMI|和田地区,HETIAN|阿勒泰地区,ALETAI|克孜勒苏柯尔克孜自治州,KEZILESU|博尔塔拉蒙古自治州,BOERTALA|克拉玛依市,KELAMAYI|乌鲁木齐市,WULUMUQI|石河子市,SHIHEZI|昌吉回族自治州,CHANGJI|五家渠市,WUJIAQU|吐鲁番市,TULUFAN|巴音郭楞蒙古自治州,BAYINGUOLENG|阿克苏地区,AKESU|阿拉尔市,ALAER|喀什地区,KASHI|图木舒克市,TUMUSHUKE|伊犁哈萨克自治州,YILI|呼伦贝尔市,HULUNBEIER|呼和浩特市,HUHEHAOTE|包头市,BAOTOU|乌海市,WUHAI|乌兰察布市,WULANCHABU|通辽市,TONGLIAO|赤峰市,CHIFENG|鄂尔多斯市,EERDUOSI|巴彦淖尔市,BAYANNAOER|锡林郭勒盟,XILINGUOLE|兴安盟,XINGANMENG|阿拉善盟,ALASHAN|台北市,TAIBEI|高雄市,GAOXIONG|基隆市,JILONG|台中市,TAIZHONG|台南市,TAINAN|新竹市,XINZHU|嘉义市,JIAYI|澳门特别行政区,AOMEN|香港特别行政区,XIANGGANG|三沙市,SANSHA|铁门关市,TIEMENGUAN";
    private static String[] cityArr;

//    @Value("${product-filter.url}")
//    private String filterUrl;

    static {
        cityArr = citys.split("\\|");
    }

    //准入
    private static final String ISREGISTERED = "/rzr/TransferV2/IsRegistered";
    //注册推送
    private static final String REGISTER = "/rzr/TransferV2/Register";

    @Resource
    private EgApiService egApiService;

    @Resource
    private RetryRestTemplate httpRestTemplate;

    @Override
    public ServerCodeEnums getType() {
        return ServerCodeEnums.DongFangRZ;
    }

    public DataVo qualityCheck(UserBaseInfoCmd userInfo, PlanCmd product, EgLoanApiConfigInfoCmd configInfo)  {

        String cellPhoneNumber = userInfo.getUserMobileMD5().toLowerCase();
        Boolean isNotBlack = preFilter(cellPhoneNumber);
        if(!isNotBlack){
            log.info("东方融资网准入失败，用户手机号在黑名单中:{}",cellPhoneNumber);
            return DataVo.fail(1, "东方融资网准入失败，用户手机号在黑名单中", product.getPlanId());
        }


        Object deserialize = HessianUtils.deserialize(configInfo.getRequestConfig());
        JSONObject data = JSONObject.parseObject(deserialize.toString());
        String url = data.getString("url");
        String timeStampStr = DateUtil.getFormatDate(new Date(), "yyyyMMddHHmmss");
        JSONObject body = new JSONObject();
        body.put("CellPhoneNumber", cellPhoneNumber);
        body.put("TimeStamp", timeStampStr);
        String secret = data.getString("secret");
        body.put("Signature", Md5Util.encoderByMd5(cellPhoneNumber + timeStampStr + secret).toLowerCase());
        body.put("UtmSource", data.getString("channelCode"));
        String msg = "";
        try {
            log.info("credit qualityCheck DfrzwCreditService userId:{},url={}, request:{}", userInfo.getUserId(), url, body.toJSONString());
            String response = httpRestTemplate.restTemplate().postForObject(url + ISREGISTERED, body.toJSONString(), String.class);
            log.info("credit qualityCheck DfrzwCreditService userId:{}, response:{}", userInfo.getUserId(), response);
            if (!StringUtils.isBlank(response)) {
                JSONObject jsonObject = JSONObject.parseObject(response);
                if (jsonObject.getIntValue("Code") == 0) {
                    Boolean isRegistered = jsonObject.getBoolean("IsRegistered");
                    if (!isRegistered) {
                        log.info("credit qualityCheck DfrzwCreditService check success phoneMd5:{}", cellPhoneNumber);
                        return DataVo.success(0, "success", product.getPlanId());
                    }
                    msg = " 准入未通过";
                }
            }
        } catch (Exception e) {
            log.error("qualityCheck DfrzwCreditService exception", e);
            msg = " 异常 " + e.getMessage();
        }
        return DataVo.fail(1, String.format("东方融资网准入%s", msg), product.getPlanId());
    }


    /**
     * 针对投放计划中包含东方融资网的投放，都做黑名单的前筛
     * 由于前筛数据量太大，前筛服务单独部署，前筛数据一百多M
     * @param
     * @return
     */
    public Boolean preFilter(String phoneMd5){
        //todo
        String url ="";
//        String url = filterUrl + phoneMd5;
        try {
            HttpResponse httpResponse = httpRestTemplate.restTemplate().getForObject(url, null, null, new HashMap<>(), new HashMap<>());
            String responseStr = EntityUtils.toString(httpResponse.getEntity());
            JSONObject response = JSONObject.parseObject(responseStr, JSONObject.class);
            Integer code = response.getInteger("code");
            if(code != 200){
                return false;
            }
        } catch (Exception e) {
            log.info("东方融资网接口访问异常：{}",phoneMd5);
        }
        return true;
    }

}
