package com.hrsk.cloud.eg.infrastructure.loanMannager.threedocking.impl;

import com.hrsk.cloud.eg.clinet.dto.data.plan.command.EgLoanApiConfigInfoCmd;
import com.hrsk.cloud.eg.clinet.dto.data.plan.command.PlanCmd;
import com.hrsk.cloud.eg.clinet.dto.data.user.command.UserBaseInfoCmd;
import com.hrsk.cloud.eg.clinet.vo.DataVo;
import com.hrsk.cloud.eg.domain.common.constant.ServerCodeEnums;
import com.hrsk.cloud.eg.infrastructure.loanMannager.threedocking.LoanDockingApi;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;

/**
 * @Author zhangyy
 * @Date 2023 11 08.
 * 用于处理所有不撞库的助贷相关逻辑
 **/
@Component
@Slf4j
public class PubNoCheckCreditService implements LoanDockingApi {



    @Override
    public ServerCodeEnums getType() {
        return ServerCodeEnums.NoCheck;
    }
    /**
     * 撞库 虚假的撞库   暂时直接返回成功，后续需要兼容排重包等功能
     *
     * @param userInfo
     * @param product
     * @return
     */
    @Override
    public DataVo qualityCheck(UserBaseInfoCmd userInfo, PlanCmd product, EgLoanApiConfigInfoCmd configInfoCmd) {
        log.info("虚假的助贷撞库请求参数 userInfo：{}  product:{}", userInfo, product);
        String productName = "";
        if (null != product && StringUtils.isNotBlank(product.getPlanName())){
            productName = product.getPlanName();
        }
        return DataVo.success(0, productName+"撞库成功", product.getPlanId());
    }
}
