package com.hrsk.cloud.eg.infrastructure.repository.database.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @author: bianlanzhou
 * @create: 2024-08-01 18:04
 * @description: DO基础类，公共字段
 **/
@Data
public class BaseDo implements Serializable {
    /**
     * 主键
     */
    private Long id;
    /**
     * 创建人ID
     */
    @TableField(fill = FieldFill.INSERT)
    private String createUid;
    /**
     * 创建名称
     */
    @TableField(fill = FieldFill.INSERT)
    private String createUsername;
    /**
     * 创建时间
     */
    @TableField(value ="gmt_create",fill = FieldFill.INSERT)
    private Date gmtCreate;
    /**
     * 修改人ID
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String modifyUid;
    /**
     * 修改人名称
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private String modifyUsername;
    /**
     * 修改时间
     */
    @TableField(value ="gmt_modify" , fill = FieldFill.INSERT_UPDATE)
    private Date gmtModify;
    /**
     * 状态 有效（Y 有效 N 无效）
     */
    @TableField(fill = FieldFill.INSERT)
    private String status;

}
