package com.hrsk.cloud.eg.infrastructure.repository.database.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.experimental.Accessors;
import java.io.Serializable;
import java.util.Date;

/**
 * 商户对接配置信息表
 *
 * @author zhangyy
 * @date 2023.05.09 10:11
 */
@Data
@Accessors(chain = true)
@TableName("product_business_api_info")
public class ProductBusinessApiInfoDo implements Serializable {

    private Integer id;

    /**
     * 商户编号
     * */
    private String busiId;

    /**
     * 对接类型 1-惠融易客 2-API
     * */
    private String joinKind;

    /**
     * 对接方式 1 -我方通用API 2-合作方CRM 3-三方CRM(ec) 4-三方CRM(庆鱼)  5-三方CRM(锦碟) 6-三方CRM(融享客)
     * */
    private String joinMethod;

    /**
     * 类型
     * */
    private String jointType;

    /**
     * 对接我方API撞库地址
     * */
    private String openapiCheckUrl;


    /**
     * 对接我方API注册地址
     * */
    private String openapiBizUrl;

     /**
     * 对接我方API公钥
     * */
    private String openapiAccessKeySecret;

    /**
     * 三方平台对接参数
     * */
    private String threeSystemConfig;

    /**
     * 合作方自研对接参数
     * */
    private String joinTypeConfig;

    private String creater;

    private String updater;

    private Date createTime;

    private Date updateTime;

    private Integer crmChannelInitStatus;

    private String remark;

    private Date syncTime;

    private String name;

    /**
     * 对接方式
     * */
    private String dockingMethod;

    /**
     * 运营负责人Id
     * */
    private String operationId;


    /**
     * 运营负责人
     * */
    private String operation;

    private Integer createId;

    private String contractSignaturerId;

    private String contractSignaturer;

    private String shareRange;

    /**
     * 共享信息目的
     * */
    private String sharePurpose;

    /**
     * 共享方式
     * */
    private String shareType;

    /**
     * 助贷商户用户协议
     * */
    private String protocol;

    /**
     * 技术维护人id
     * */
    private Integer maintenanceId;

    /**
     * 技术维护人
     * */
    private String maintenance;

    /**
     * 是否是需要撞库
     */
    private Integer needCheck;


}
