package com.hrsk.cloud.eg.infrastructure.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.hrsk.cloud.eg.infrastructure.repository.database.entity.EgApiEndpointDo;
import com.hrsk.cloud.eg.infrastructure.repository.database.mapper.EgApiEndpointMapper;
import com.hrsk.cloud.eg.infrastructure.service.EgApiEndpointService;
import org.springframework.stereotype.Service;

/**
 * @author zhangyy
 * @version 1.0
 * @description: EgApiEndpointServiceImpl
 * @date 2024/8/28 11:02
 */
@Service
public class EgApiEndpointServiceImpl extends ServiceImpl<EgApiEndpointMapper, EgApiEndpointDo> implements EgApiEndpointService {

    @Override
    public EgApiEndpointDo findByApiId(Integer apiId) {

        LambdaQueryWrapper<EgApiEndpointDo> queryWrapper=new LambdaQueryWrapper<>();
        queryWrapper.eq(EgApiEndpointDo::getApiId, apiId);
        queryWrapper.orderByDesc(EgApiEndpointDo::getId);
        queryWrapper.last("limit 1");
        EgApiEndpointDo egApiEndpointDo = baseMapper.selectOne(queryWrapper);
        if (egApiEndpointDo == null) {
            return new EgApiEndpointDo();
        }
        return egApiEndpointDo;
    }
}
