import com.alibaba.fastjson2.JSONObject;
import com.hrsk.cloud.eg.Application;
import com.hrsk.cloud.eg.app.loan.executor.GenerateCheckIntoHttpApiConfigCmdExe;
import com.hrsk.cloud.eg.app.loan.executor.GenerateCheckIntoHttpApiConfigV2CmdExe;
import com.hrsk.cloud.eg.infrastructure.repository.database.entity.ProductBusinessApiInfoDo;
import com.hrsk.cloud.eg.infrastructure.service.ProductBusinessApiInfoService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author zhangyy
 * @version 1.0
 * @description: GenerateConfigTest
 * @date 2024/9/9 15:13
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = Application.class)
public class GenerateConfigTest {

    @Resource
    private GenerateCheckIntoHttpApiConfigCmdExe generateCHeckIntoHttpApiConfigCmdExe;

    @Resource
    private ProductBusinessApiInfoService productBusinessApiInfoService;

    @Resource
    private GenerateCheckIntoHttpApiConfigV2CmdExe generateCheckIntoHttpApiConfigV2CmdExe;

    @Test
    public void createHuiRonApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointCodeForList("9");
        String jsonString = JSONObject.toJSONString(productBusinessApiInfoDos.get(0));
        generateCHeckIntoHttpApiConfigCmdExe.generateHuiRonHuiRonApiConfig(jsonString);
    }

    @Test
    public void createOpenApiRsaTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointCodeForList("1");
        String jsonString = JSONObject.toJSONString(productBusinessApiInfoDos.get(0));
        generateCHeckIntoHttpApiConfigCmdExe.generateOpenApiRSAConfig(jsonString);
    }


    @Test
    public void createQinYuApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointCodeForList("4");
//        String jsonString = JSONObject.toJSONString(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
        generateCHeckIntoHttpApiConfigCmdExe.generateQinYuConfig(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
    }

    @Test
    public void createJinDieApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointCodeForList("5");
//        String jsonString = JSONObject.toJSONString(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
        generateCHeckIntoHttpApiConfigCmdExe.generateJinDieConfig(productBusinessApiInfoDos.get(1).getThreeSystemConfig());
    }


    @Test
    public void createXinLuApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointCodeForList("7");
        generateCHeckIntoHttpApiConfigCmdExe.generateXinLuConfig(productBusinessApiInfoDos.get(1).getThreeSystemConfig());
    }

    @Test
    public void createXkdApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointCodeForList("10");
        generateCHeckIntoHttpApiConfigCmdExe.generateXinLuConfig(productBusinessApiInfoDos.get(1).getThreeSystemConfig());
    }


    @Test
    public void createRxkApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointCodeForList("6");
        generateCHeckIntoHttpApiConfigCmdExe.generateRxkConfig(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
    }

    @Test
    public void createHuiZhonApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointJonintTypeForList("Huizhong");
        generateCHeckIntoHttpApiConfigCmdExe.generateHuiZhongConfig(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
    }

    @Test
    public void createYinHuaApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointJonintTypeForList("YinHua");
        generateCHeckIntoHttpApiConfigCmdExe.generateYinHuaConfig(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
    }

    @Test
    public void createHuiXinApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointJonintTypeForList("Huixin");
        generateCHeckIntoHttpApiConfigCmdExe.generateHuixinConfig(productBusinessApiInfoDos.get(1).getThreeSystemConfig());
    }


    @Test
    public void createYuKuaiHuaApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointJonintTypeForList("YuKuaiHua");
        generateCHeckIntoHttpApiConfigCmdExe.generateYuKuaiHuaConfig(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
    }


    @Test
    public void createYinJieHuaApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointJonintTypeForList("YiJie");
        generateCHeckIntoHttpApiConfigCmdExe.generateYinJieConfig(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
    }


    @Test
    public void createYouRonApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointJonintTypeForList("Yourong");
        generateCHeckIntoHttpApiConfigCmdExe.generateYouRonConfig(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
    }

    @Test
    public void createHamiguaApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointJonintTypeForList("Hamigua");
        generateCHeckIntoHttpApiConfigCmdExe.generateHamiguaConfig(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
    }

    @Test
    public void createHaohanwuyinApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointJonintTypeForList("Haohanwuyin");
        generateCHeckIntoHttpApiConfigCmdExe.generateHaohanwuyinConfig(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
    }

    @Test
    public void createGexinjinfuApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointJonintTypeForList("Gexinjinfu");
        generateCheckIntoHttpApiConfigV2CmdExe.generateGexinjinfuConfig(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
    }

    @Test
    public void createKuaiyidaiApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointJonintTypeForList("Kuaiyidai");
        generateCheckIntoHttpApiConfigV2CmdExe.generateKuaiyidaiConfig(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
    }

    @Test
    public void createKuaiyidaiNightApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointJonintTypeForList("KuaiyidaiNight");
        generateCheckIntoHttpApiConfigV2CmdExe.generateKuaiyidaiConfig(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
    }

    @Test
    public void createKuaiyidaiFourToOneApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointJonintTypeForList("KuaiyidaiFourToOne");
        generateCheckIntoHttpApiConfigV2CmdExe.generateKuaiyidaiConfig(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
    }


    @Test
    public void createKuaiyidaiV2ApiTest(){
        List<ProductBusinessApiInfoDo> productBusinessApiInfoDos = productBusinessApiInfoService.selectByJointJonintTypeForList("KuaiyidaiV2");
        generateCheckIntoHttpApiConfigV2CmdExe.generateKuaiyidaiConfig(productBusinessApiInfoDos.get(0).getThreeSystemConfig());
    }

}


